JDBCDriver (HSQLDB 2.4.1 API)
Date: 2018-05-20

org.hsqldb.jdbc

## Class JDBCDriver

- java.lang.Object
- - org.hsqldb.jdbc.JDBCDriver

- All Implemented Interfaces:
    java.sql.Driver

      public class JDBCDriver
      extends java.lang.Object
      implements java.sql.Driver

  Provides the java.sql.Driver interface implementation required by the JDBC specification.

  The Java SQL framework allows for multiple database drivers.

  The DriverManager will try to load as many drivers as it can find and then for any given connection request, it will ask each driver in turn to try to connect to the target URL.

  The application developer will normally not need to call any function of the Driver directly. All required calls are made by the DriverManager.

  ### HSQLDB-Specific Information:

  When the HSQL Database Engine Driver class is loaded, it creates an instance of itself and register it with the DriverManager. This means that a user can load and register the HSQL Database Engine driver by calling:

        Class.forName("org.hsqldb.jdbc.JDBCDriver")

  For detailed information about how to obtain HSQLDB JDBC Connections, please see `JDBCConnection`.

  JDBC 4.0 notes:

  Starting with JDBC 4.0 (JDK 1.6), the `DriverManager` methods `getConnection` and `getDrivers` have been enhanced to support the Java Standard Edition Service Provider mechanism. When built under a Java runtime that supports JDBC 4.0, HSQLDB distribution jars containing the Driver implementation also include the file `META-INF/services/java.sql.Driver`. This file contains the fully qualified class name ('org.hsqldb.jdbc.JDBCDriver') of the HSQLDB implementation of `java.sql.Driver`.

  Hence, under JDBC 4.0 or greater, applications no longer need to explicitly load the HSQLDB JDBC driver using `Class.forName()`. Of course, existing programs which do load JDBC drivers using `Class.forName()` will continue to work without modification.

  JDBC 4.2 methods added in Java 8 are generally supported when the HSQLDB jar is compiled with JDK 8

  Since:
    HSQLDB 1.9.0
  Author:
    Campbell Burnet (campbell-burnet@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)
  See Also:
    `JDBCConnection`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static JDBCDriver` | `driverInstance`
    `java.lang.ThreadLocal<JDBCConnection>` | `threadConnection` As a separate instance of this class is registered with DriverManager for each class loader, the threadConnection is not declared as static.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JDBCDriver()` Default constructor

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `acceptsURL(java.lang.String url)` Returns true if the driver thinks that it can open a connection to the given URL.
    `java.sql.Connection` | `connect(java.lang.String url, java.util.Properties info)` Attempts to make a database connection to the given URL.
    `static java.sql.Connection` | `getConnection(java.lang.String url, java.util.Properties info)` The static equivalent of the `connect(String,Properties)` method.
    `int` | `getMajorVersion()` Gets the driver's major version number.
    `int` | `getMinorVersion()` Gets the driver's minor version number.
    `java.util.logging.Logger` | `getParentLogger()` Return the parent Logger of all the Loggers used by this driver.
    `java.sql.DriverPropertyInfo[]` | `getPropertyInfo(java.lang.String url, java.util.Properties info)` Gets information about the possible properties for this driver.
    `boolean` | `jdbcCompliant()` Reports whether this driver is a genuine JDBC Compliant™ driver.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### driverInstance

          public static final JDBCDriver driverInstance

    - #### threadConnection

          public final java.lang.ThreadLocal<JDBCConnection> threadConnection

      As a separate instance of this class is registered with DriverManager for each class loader, the threadConnection is not declared as static. The registered instance is kept to allow access to the its threadConnection.

  - ### Constructor Detail

    - #### JDBCDriver

          public JDBCDriver()

      Default constructor

  - ### Method Detail

    - #### connect

          public java.sql.Connection connect(java.lang.String url,
                                             java.util.Properties info)
                                      throws java.sql.SQLException

      Attempts to make a database connection to the given URL.

      Returns "null" if this is the wrong kind of driver to connect to the given URL. This will be common, as when the JDBC driver manager is asked to connect to a given URL it passes the URL to each loaded driver in turn.

      The driver throws an `SQLException` if it is the right driver to connect to the given URL but has trouble connecting to the database.

      The `java.util.Properties` argument can be used to pass arbitrary string tag/value pairs as connection arguments. Normally at least "user" and "password" properties should be included in the `Properties` object.

      ### HSQLDB-Specific Information:

      For the HSQL Database Engine, at least "user" and "password" properties should be included in the Properties.

      From version 1.7.1, two optional properties are supported:

      - `get_column_name` (default true) - if set to false, a ResultSetMetaData.getColumnName() call will return the user defined label (getColumnLabel()) instead of the column name.
        This property is available in order to achieve compatibility with certain non-HSQLDB JDBC driver implementations.
      - `strict_md` if set to true, some ResultSetMetaData methods return more strict values for compatibility reasons.

      From version 1.8.0.x, `strict_md` is deprecated (ignored) because metadata reporting is always strict (JDBC-compliant), and three new optional properties are supported:

      - `ifexits` (default false) - when true, an exception is raised when attempting to connect to an in-process file: or mem: scheme database instance if it has not yet been created. When false, an in-process file: or mem: scheme database instance is created automatically if it has not yet been created. This property does not apply to requests for network or res: (i.e. files_in_jar) scheme connections.
      - `shutdown` (default false) - when true, the the target database mimics the behaviour of 1.7.1 and older versions. When the last connection to a database is closed, the database is automatically shut down. The property takes effect only when the first connection is made to the database. This means the connection that opens the database. It has no effect if used with subsequent, simultaneous connections.
        This command has two uses. One is for test suites, where connections to the database are made from one JVM context, immediately followed by another context. The other use is for applications where it is not easy to configure the environment to shutdown the database. Examples reported by users include web application servers, where the closing of the last connection coincides with the web application being shut down.
      - `default_schema` - backwards compatibility feature. To be used for clients written before HSQLDB schema support. Denotes whether to use the default schema when a schema qualifier is not included in a database object's SQL identifier character sequence. Also affects the semantics of DatabaseMetaData calls that supply null-valued schemaNamePattern parameter values.
      Specified by:
        `connect` in interface `java.sql.Driver`
      Parameters:
        `url` - the URL of the database to which to connect
        `info` - a list of arbitrary string tag/value pairs as connection arguments. Normally at least a "user" and "password" property should be included.
      Returns:
        a `Connection` object that represents a connection to the URL
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getConnection

          public static java.sql.Connection getConnection(java.lang.String url,
                                                          java.util.Properties info)
                                                   throws java.sql.SQLException

      The static equivalent of the `connect(String,Properties)` method.

      Parameters:
        `url` - the URL of the database to which to connect
        `info` - a list of arbitrary string tag/value pairs as connection arguments including at least at a "user" and a "password" property
      Returns:
        a `Connection` object that represents a connection to the URL
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### acceptsURL

          public boolean acceptsURL(java.lang.String url)

      Returns true if the driver thinks that it can open a connection to the given URL. Typically drivers will return true if they understand the subprotocol specified in the URL and false if they don't.
      Specified by:
        `acceptsURL` in interface `java.sql.Driver`
      Parameters:
        `url` - the URL of the database
      Returns:
        true if this driver can connect to the given URL

    - #### getPropertyInfo

          public java.sql.DriverPropertyInfo[] getPropertyInfo(java.lang.String url,
                                                               java.util.Properties info)

      Gets information about the possible properties for this driver.

      The getPropertyInfo method is intended to allow a generic GUI tool to discover what properties it should prompt a human for in order to get enough information to connect to a database. Note that depending on the values the human has supplied so far, additional values may become necessary, so it may be necessary to iterate though several calls to getPropertyInfo.

      ### HSQLDB-Specific Information:

      HSQLDB uses the values submitted in info to set the value for each DriverPropertyInfo object returned. It does not use the default value that it would use for the property if the value is null.

      Specified by:
        `getPropertyInfo` in interface `java.sql.Driver`
      Parameters:
        `url` - the URL of the database to which to connect
        `info` - a proposed list of tag/value pairs that will be sent on connect open
      Returns:
        an array of DriverPropertyInfo objects describing possible properties. This array may be an empty array if no properties are required.

    - #### getMajorVersion

          public int getMajorVersion()

      Gets the driver's major version number.
      Specified by:
        `getMajorVersion` in interface `java.sql.Driver`
      Returns:
        this driver's major version number

    - #### getMinorVersion

          public int getMinorVersion()

      Gets the driver's minor version number.
      Specified by:
        `getMinorVersion` in interface `java.sql.Driver`
      Returns:
        this driver's minor version number

    - #### jdbcCompliant

          public boolean jdbcCompliant()

      Reports whether this driver is a genuine JDBC Compliant™ driver. A driver may only report `true` here if it passes the JDBC compliance tests; otherwise it is required to return `false`.

      JDBC compliance requires full support for the JDBC API and full support for SQL 92 Entry Level.

      ### HSQLDB-Specific Information:

      HSQLDB 2.0 is aimed to be compliant with JDBC 4.2 specification. It supports SQL 92 Entry Level and beyond.

      This method is not intended to encourage the development of non-JDBC compliant drivers, but is a recognition of the fact that some vendors are interested in using the JDBC API and framework for lightweight databases that do not support full database functionality, or for special databases such as document information retrieval where a SQL implementation may not be feasible.
      Specified by:
        `jdbcCompliant` in interface `java.sql.Driver`
      Returns:
        `true` if this driver is JDBC Compliant; `false` otherwise

    - #### getParentLogger

          public java.util.logging.Logger getParentLogger()
                                                   throws java.sql.SQLFeatureNotSupportedException

      Return the parent Logger of all the Loggers used by this driver. This should be the Logger farthest from the root Logger that is still an ancestor of all of the Loggers used by this driver. Configuring this Logger will affect all of the log messages generated by the driver. In the worst case, this may be the root Logger.
      Specified by:
        `getParentLogger` in interface `java.sql.Driver`
      Returns:
        the parent Logger for this driver
      Throws:
        `java.sql.SQLFeatureNotSupportedException` - if the driver does not use `java.util.logging`.
      Since:
        JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.0.1

Copyright © 2001 - 2018 HSQL Development Group.